This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 712694 - (CVE-2011-2201) CVE-2011-2201 perl-Data-FormValidator: Reports invalid field as valid when untaint_all_constraints used
CVE-2011-2201 perl-Data-FormValidator: Reports invalid field as valid when un...
Status: CLOSED ERRATA
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
low Severity low
: ---
: ---
Assigned To: Red Hat Product Security
public=20100930,reported=20110607,sou...
: Security
Depends On: 712699
Blocks:
  Show dependency treegraph
 
Reported: 2011-06-12 10:35 EDT by Jan Lieskovsky
Modified: 2011-09-09 04:27 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-09-09 04:27:57 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Jan Lieskovsky 2011-06-12 10:35:17 EDT
It was found that perl-Data-FormValidator, a HTML form user input validator,
used to treat certain invalid fields as valid, when the
untaint_all_constraints directive was used (default for majority of
Data-FormValidator routines). A remote attacker could use this flaw to bypass
perl Taint mode protection mechanism via specially-crafted input provided to
the HTML form.

References:
[1] http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=629511
[2] https://rt.cpan.org/Public/Bug/Display.html?id=61792
Comment 1 Jan Lieskovsky 2011-06-12 10:36:48 EDT
This issue affect the versions of the perl-Data-FormValidator package, as
shipped with Fedora release of 13, 14, and 15. Please schedule an update
(once final upstream patch known / ready).
Comment 2 Jan Lieskovsky 2011-06-12 10:51:13 EDT
CVE Request:
[3] http://www.openwall.com/lists/oss-security/2011/06/12/3
Comment 3 Jan Lieskovsky 2011-06-12 10:53:53 EDT
Public PoC (from [2]):
======================

#!/opt/perl/5.12/bin/perl

use strict;
use warnings;

use Data::FormValidator;

"some_unrelated_string" =~ m/^.*$/;

my $profile = {
untaint_all_constraints => 1,
required => [qw(a)],
constraint_methods => {
a => qr/will_never_match/,
},
};

my $results = Data::FormValidator->check({ a => 1 }, $profile);
warn $results->valid('a');

Have tried on my F-15 machine (perl-Data-FormValidator-4.66-4.fc15.noarch)
as:

$ cat test.pl 
#!/usr/bin/perl -w
use strict;
use warnings;
use Data::Dumper;

use Data::FormValidator;

"some_unrelated_string" =~ m/^.*$/;

my $profile = {
untaint_all_constraints => 1,
required => [qw(a)],
constraint_methods => {
a => qr/will_never_match/,
},
};

my $results = Data::FormValidator->check({ a => 1 }, $profile);
print $results->valid,"\n";

and 'a' is reported as being valid.
Comment 4 Jan Lieskovsky 2011-06-12 10:54:58 EDT
Created perl-Data-FormValidator tracking bugs for this issue

Affects: fedora-all [bug 712699]
Comment 5 Jan Lieskovsky 2011-06-14 06:27:37 EDT
The CVE identifier of CVE-2011-2201 has been assigned to this issue:
http://www.openwall.com/lists/oss-security/2011/06/13/13

Note You need to log in before you can comment on or make changes to this bug.